<?php
/******************************
 * $Id: functions.lib.php
 * org by Nefuh $
 * @version    1.1.1
 * @author     Tennessee
 * @date 20008-06-03
 ******************************/

/** 
* 	Function to get addon configuration from database
* 	This functions overrides setttings set in conf.php
*/
function load_addon_config() 
{
  	GLOBAL $wowdb, $addon_conf, $db_prefix, $roster_conf;
  	$sql = "SELECT * FROM `".$db_prefix."karmaconfig` ORDER BY `config_id`";
  	$result = $wowdb->query($sql);
  	if ($wowdb->num_rows($result) > 0) 
  	{
	  	while ($data = $wowdb->fetch_array($result)) 
		{
			$addon_conf['karmahistory'][$data['config_name']] = $data['config_value'];
		}
	}
}

/** 
* 	Function to load guildvault config (like tabname) from database
*	@return | Returns the data in an array
*/
function load_config() {
  	GLOBAL $wowdb, $roster_conf, $db_prefix, $failed_querys, $addon_conf;
	$sql = "SELECT * FROM `".$db_prefix."karmaconfig` ORDER BY `config_id` ASC";
	if (!$result = $wowdb->query($sql)) {
	 	$failed_queries[] = $sql; 
	}
	while ($data = mysql_fetch_array($result)) {
  	$config[$data['tab']]['name'] = $data['name'];
		
		$config[$data['tab']]['icon'] = $data['icon'];
	}
	return $config;
}

/** 
* 	Function to update the configuration with the values from form.
*	@return | Returns process message
*/
function update_config() {
  	global $script_filename, $roster_conf, $addon_conf, $wordings, $db_prefix, $wowdb;
  	$sql = "SELECT * FROM `".$db_prefix."karmaconfig` ORDER BY `config_id`";
  	$result = $wowdb->query($sql);
  	while ($data = $wowdb->fetch_array($result)) 
	{
		$alt_config[$data['config_name']] = $data['config_value'];	    
	}
	$keys = array_keys($alt_config);
	$message = '<ul class="karmahistory_update_messages">';
	$message .= '<li class="karmahistory_update_messages">'.$wordings[$roster_conf['roster_lang']]['karmahistory'].'</li>';
	$message .= '<li class="karmahistory_update_messages"><hr /></li>';
	foreach ($keys as $key) 
	{
		if ((isset($_REQUEST[$key])) && ($_REQUEST[$key] != '')) 
		{
			if ($key == 'password') 
			{
				$new_config[$key] = md5($_REQUEST[$key]);
			}
			else 
			{
				$new_config[$key] = $_REQUEST[$key];
			}  
			$sql = "UPDATE `".$db_prefix."karmaconfig` SET `config_value` = '".$new_config[$key]."' WHERE `config_name` = '$key'";
			if ($wowdb->query($sql)) {
			  	$message .= '<li class="karmahistory_update_messages">'.$key.' - '.$wordings[$roster_conf['roster_lang']]['karma_updated'].'</li>';
			}
			else {
			  	$message .= '<li class="karmahistory_update_messages">'.$key.' - '.$wordings[$roster_conf['roster_lang']]['karma_notupdated'].'</li>';
			}
			if ($addon_conf['karmahistory']['debug']) 
			{
				$message .= '<li class="karmahistory_update_messages"><ul><li>'.$sql.'</li></ul></li>'."\n";
			}
		}  
	}
	$message .= '<li class="karmahistory_update_messages"><hr /></li>';
	$message .= '<li class="karmahistory_update_messages">'.$wordings[$roster_conf['roster_lang']]['karma_updatedone'].'</li>';
	$message .= '</ul>';
	return $message;
}

/** 
* 	Function to display and change the addon configuration.
*	@return | Returns a form with the addon configuration
*/
function display_configuration() {
  	GLOBAL $roster_conf, $addon_conf, $wordings, $wowdb, $db_prefix;
  	$keys[] = 'karmahistory';
  	$additional_fields[0]['type'] = 'hidden';
  	$additional_fields[0]['name'] = 'task';
  	$additional_fields[0]['value'] = 'update_config';
  	$display = make_form_header('', $additional_fields);
  	$sql = "SELECT * FROM `".$db_prefix."karmaconfig` ORDER BY `config_id`";
  	$result = $wowdb->query($sql);
	while ($data = $wowdb->fetch_array($result)) 
	{
	  	$db_values['karmahistory'][$data['config_id']]['name'] = $data['config_name'];
	  	$db_values['karmahistory'][$data['config_id']]['value'] = $data['config_value'];
	  	$db_values['karmahistory'][$data['config_id']]['form_type'] = $data['config_form_type'];
	  	if (isset($wordings[$roster_conf['roster_lang']][$data['config_name']])) {
		  	$db_values['karmahistory'][$data['config_id']]['description'] = $wordings[$roster_conf['roster_lang']][$data['config_name']];
		}
	
		
		else {
		  	$db_values['karmahistory'][$data['config_id']]['description'] = $data['config_name'];		  
		}
	}
	$html = '';
	$k = 0;
	foreach($keys as $type)
	{
		$i = 0;
		
      $display .= '<table cellspacing="1" cellpadding="2" class="bodyline">';
		foreach($db_values[$type] as $values)
		{
			// Here is my nifty auto form generator
			// Takes `form_type` from the db and parses it for form type values and labels
			// Any un-handled form type will cause this file to just display the current value

			// Figure out input type
			$input_field = '';
			$input_type = explode('{',$values['form_type']);

			switch ($input_type[0])
			{
				case 'text':
					$length = explode('|',$input_type[1]);

					if( $length[1] < 20 )
						$text_class = '64';
					elseif( $length[1] < 30 )
						$text_class = '128';
					elseif( $length[1] < 40 )
						$text_class = '192';
					else
						$text_class = '';
					if ($values['name'] == 'password')
					{
						$input_field = '<input class="wowinput'.$text_class.'" name="'.$values['name'].'" type="password" value="" size="'.$length[1].'" maxlength="'.$length[0].'" />';
					}
					else 
					{
						$input_field = '<input class="wowinput'.$text_class.'" name="'.$values['name'].'" type="text" value="'.$values['value'].'" size="'.$length[1].'" maxlength="'.$length[0].'" />';
					}
					break;
	
				case 'radio':
					$options = explode('|',$input_type[1]);
					$rad=0;
					foreach( $options as $value )
					{
						$vals = explode('^',$value);
						$input_field .= '<input type="radio" id="rad'.$k.'_'.$i.'_'.$rad.'" name="'.$values['name'].'" value="'.$vals[1].'"'.( $values['value'] == $vals[1] ? ' checked="checked"' : '' ).' /><label for="rad'.$k.'_'.$i.'_'.$rad.'">'.$vals[0]."</label>\n";
						$rad++;
					}
					break;
	
				case 'select':
					$options = explode('|',$input_type[1]);
					$input_field .= '<select name="'.$values['name'].'">'."\n";
					$select_one = 1;
					foreach( $options as $value )
					{
						$vals = explode('^',$value);
						if( $values['value'] == $vals[1] && $select_one )
						{
							$input_field .= '  <option value="'.$vals[1].'" selected="selected">-'.$vals[0].'-</option>'."\n";
							$select_one = 0;
						}
						else
						{
							$input_field .= '  <option value="'.$vals[1].'">'.$vals[0].'</option>'."\n";
						}
					}
					$input_field .= '</select>';
					break;

				case 'function':
					$input_field = $input_type[1]();
					break;

				case 'display':
					$input_field = $values['value'];
					break;

				default:
					$input_field = $values['value'];
					break;
			}

			$display .= '	<tr>
						<td class="membersRow'.(($i%2)+1).'">'.$values['description'].'</td><td class="membersRowRight'.(($i%2)+1).'"><div align="right">'
						.$input_field.'</div></td>
						</tr>'."\n";

			$i++;
		}

		$k++;
	}
	$display .= '<tr><td><input type="submit" value="Save Settings" /><input type="reset" name="Reset" value="Reset" onClick="return confirm('.$wordings[$roster_conf['roster_lang']]['confirm_config_reset'].')"/></td></tr>';
	$display .= '</table></form>'."\n";
	return $display;
}


function makelink($parameters = '') 
{
	GLOBAL $roster_conf, $addon_conf, $script_filename;
	$addonname = 'karmahistory';
	$parameters = trim($parameters, '&amp;');
	  	if ($parameters != '') {
		  	$link = $script_filename.'&amp;'.$parameters;
		}
		else {
		  	$link = $script_filename;
		}
	
	return $link;
}

function make_form_header($filename, $additional_fields = null, $name = 'form1', $method = 'post', $encoding_type = 'multipart/form-data', $onsubmit = null) 
{
  	global $script_filename, $addon_conf;
  	if ($filename == '') 
  	{
		$filename = $script_filename;
    }
      $form = '<!--- NORMAL MODE --><form action="'.$filename.'" name="'.$name.'" method="'.$method.'" enctype="'.$encoding_type.'" onsubmit="'.$onsubmit.'">';
	
	if ((isset($additional_fields)) && (is_array($additional_fields))) 
	{
	  	foreach ($additional_fields as $field) 
		{
		    $form .= "<input type=\"".$field['type']."\" name=\"".$field['name']."\" value=\"".$field['value']."\" />";
		}
	}
	
	return $form;
}

/** 
* 	Function to check if all needed tables are existing, else create them
*/
function check_all_tables() 
{
  	global $roster_conf, $addon_conf, $wowdb, $db_prefix, $failed_queries, $addonDir;
  	if (!defined('ROSTER_KARMACONFIG_TABLE')) {
	    require_once ($addonDir.'conf.php');
	}

	$table_karma_exists = checkDb($db_prefix.'karma');
	$table_karmalog_exists = checkDb($db_prefix.'karmalog');
	$table_karmaitems_exists = checkDb($db_prefix.'karmaitems');
	$table_karmaconfig_exists = checkDb($db_prefix.'karmaconfig');


	if ($table_karmaitems_exists != true) 
	{
  		$sql = "CREATE TABLE IF NOT EXISTS `".$db_prefix."karmaitems` (
	  		`member_id` int(11) UNSIGNED NOT NULL default '0', 
				`value` int(10) NOT NULL,
        `type` varchar(2) NOT NULL,
        `reason` varchar(32) NOT NULL,
        `DT` varchar(24) NOT NULL,
        `shortdt` varchar(8) NOT NULL,
        `class` varchar(20) NOT NULL,
        `fullname` varchar(32) NOT NULL,
        `item_parent` varchar(32) NOT NULL,
        `item_slot` int(10) NOT NULL,
        `item_name` varchar(100) NOT NULL default '',
				PRIMARY KEY  (`member_id`,`DT`),
        KEY `parent` (`item_parent`),
        KEY `DT` (`DT`),
        KEY `reason` (`reason`),
        KEY `value` (`value`),
        KEY `type` (`type`),
        KEY `fullname` (`fullname`),
        KEY `shortdt` (`shortdt`),
        KEY `slot` (`item_slot`),
        KEY `name` (`item_name`)
				) TYPE=MyISAM;";
				
		if (!$wowdb->query($sql)) 
		{
	 		$failed_queries[] = $sql; 
		}
	}
  if ($table_karma_exists != true) 
	{
  		$sql = "CREATE TABLE IF NOT EXISTS `".$db_prefix."karma` (
  `member_id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(32) NOT NULL default '',
  `class` varchar(32) NOT NULL default '',
  `lifetime` int(50) NOT NULL,
  `lastadd` varchar(64) NOT NULL,
  `points` int(100) NOT NULL,
  `fullname` varchar(64) NOT NULL,
  PRIMARY KEY  (`member_id`),
  KEY `class` (`class`),
  KEY `lifetime` (`lifetime`),
  KEY `name` (`name`),
  KEY `fullname` (`fullname`),
  KEY `member` (`name`,`fullname`)
) TYPE=MyISAM;";

		if (!$wowdb->query($sql)) 
		{
		 	$failed_queries[] = $sql; 
		}
	}
  /////////////////////////
  if ($table_karmalog_exists != true) 
	{
  		$sql = "CREATE TABLE IF NOT EXISTS `".$db_prefix."karmalog` (
  `karma_id` int(11) unsigned NOT NULL auto_increment,
  `karma_name` varchar(64) NOT NULL default '',
  `update_time` varchar(38) default NULL,
  `created_time` varchar(38) default NULL,
  PRIMARY KEY  (`karma_id`),
  KEY `karma` (`karma_name`)
  ) TYPE=MyISAM;";

		if (!$wowdb->query($sql)) 
		{
		 	$failed_queries[] = $sql; 
		}
		$dummytrick = test;
		$timeZoneOffset = $roster_conf['localtimeoffset'];
    $H = (date('h')+date('O'))+$timeZoneOffset; //hour
    $i = date('i'); //minutes
    $update_time = date('D M j\,').date(' g:i A ',mktime($H,$i)).$roster_conf['timezone'];		
		$wowdb->add_value( 'karma_name', $dummytrick );
    $wowdb->add_value( 'update_time', $update_time );
    $wowdb->add_value( 'created_time', $update_time );  
    $sql = "INSERT INTO `".$db_prefix."karmalog` SET ".$wowdb->assignstr;
 
		if (!$wowdb->query($sql)) 
		{
	 		$failed_queries[] = $sql; 
		}	                          
		unset($sql);
	}
  /////////////////////////////////      
	if ($table_karmaconfig_exists != true) 
	{   
  		$sql = "CREATE TABLE IF NOT EXISTS `".$db_prefix."karmaconfig` (
  				`config_id` int(5) NOT NULL auto_increment,
  				`config_name` varchar(255) NOT NULL,
	  			`config_value` varchar(255) NOT NULL,
  				`config_form_type` mediumtext NOT NULL,
  				PRIMARY KEY  (`config_id`),
  				KEY `config_name` (`config_name`)
				) TYPE=MyISAM;";
		if (!$wowdb->query($sql)) 
		{
		 	$failed_queries[] = $sql; 
		}
		$sql = "INSERT INTO `".$db_prefix."karmaconfig` 
				(`config_id`, `config_name`, `config_value`, `config_form_type`) VALUES  
        (2, 'useitemstats', '".$addon_conf['karmahistory']['useitemstats']."', 'radio{on^1|off^0'),
        (3, 'useclasscolor', '".$addon_conf['karmahistory']['useclasscolor']."', 'radio{on^1|off^0'),
        (4, 'userankcolor', '".$addon_conf['karmahistory']['userankcolor']."', 'radio{on^1|off^0'),
        (10, 'database', '".$addon_conf['karmahistory']['database']."', 'text{255|255'),  
				(15, 'itemstats_path', '".$addon_conf['karmahistory']['itemstats_path']."', 'text{255|255'),
				(19, 'noitemstats', '".$addon_conf['karmahistory']['noitemstats']."', 'text{255|255'),
				(34, 'clearitemdata', '".$addon_conf['karmahistory']['clearitemdata']."', 'radio{on^1|off^0'),
				(35, 'clearplayerdata', '".$addon_conf['karmahistory']['clearplayerdata']."', 'radio{on^1|off^0'),
        (101, 'rank1', '".$addon_conf['karmahistory']['rank1']."', 'text{255|255'),
        (102, 'rank2', '".$addon_conf['karmahistory']['rank2']."', 'text{255|255'),
        (103, 'rank3', '".$addon_conf['karmahistory']['rank3']."', 'text{255|255'),
        (104, 'rank4', '".$addon_conf['karmahistory']['rank4']."', 'text{255|255'),
        (105, 'rank5', '".$addon_conf['karmahistory']['rank5']."', 'text{255|255'),
        (106, 'rank6', '".$addon_conf['karmahistory']['rank6']."', 'text{255|255'),
        (107, 'rank7', '".$addon_conf['karmahistory']['rank7']."', 'text{255|255');";
				
 
		if (!$wowdb->query($sql)) 
		{
	 		$failed_queries[] = $sql; 
		}	                          
		unset($sql);
	}

}

// Function to check if DB-Table is already existing
/** 
* 	Function to check if all needed tables exists
*	@$table | The name of the table to check for
* 	@return | Return true if table was found, else return false
*/
if (!function_exists('checkDb')) 
{
	function checkDb( $table ) 
	{
		global $wowdb, $db_prefix;
		$sql_str = "SHOW TABLES LIKE '".$table."';";
		$result = $wowdb->query($sql_str);
		$r = $wowdb->fetch_assoc($result);
		if( empty($r) )
		{
			return FALSE;
		}
		else
		{
			return TRUE;
		}
	}
}