<?php
/******************************
 * WoWRoster.net  Roster
 * Copyright 2002-2007
 * Licensed under the Creative Commons
 * "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * Short summary
 *  http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * Full license information
 *  http://creativecommons.org/licenses/by-nc-sa/2.5/legalcode
 * -----------------------------
 *
 * org by zanix $
 * $Id: details.php
 * @version    1.1.1 
 * remixed for addon karmahistory date 20008-06-03 Tennessee $ 
 ******************************/
if ( !defined('ROSTER_INSTALLED') )
{
    exit('Detected invalid access to this file!');
}
unset ($mystart);
$mystart=3;
$script_filename = ('addon.php?roster_addon_name=karmahistory&amp;z=details&amp;start=');
    $get_d = ( isset($_REQUEST['d']) ? intval($_REQUEST['d']) : 0 );
    $get_s = ( isset($_REQUEST['s']) ? $_REQUEST['s'] : '' );
// Check for start for pagination
$start = (isset($_REQUEST['start']) ? $_REQUEST['start'] : 0);
 
$query =
        'SELECT  SUM(value), COUNT(reason),'.
// we limit down what it actually pulls
// The query is a lot simpler than it looks...
// Fields to get from the members table
        '`members`.`member_id`, '.
        '`members`.`name`, '.
        '`members`.`class`, '.
        '`members`.`last_online`, '.
        '`members`.`guild_rank`, '.
        '`members`.`guild_title`, '.
        
// Fields to get from the karma table
  '`life`.`points`, '. 
        '`karma`.`value`, '.
        '`karma`.`reason`, '.
        '`karma`.`type`, '.
        '`karma`.`fullname`, '.
        '`life`.`lastadd`, '.
        '`life`.`lifetime` '.
                     
         "FROM `".ROSTER_MEMBERSTABLE."` AS members ".
// All those people asking about guild searching, here's a spot!  and here's the simple alteration to stop guild filtering in this particular place     
        "LEFT JOIN `".ROSTER_KARMAITEMSTABLE."` AS karma ON `members`.`member_id` = `karma`.`member_id` ".
        
        "LEFT JOIN `".ROSTER_KARMATABLE."` AS life ON `members`.`member_id` = `life`.`member_id` ".
  "WHERE karma.type='I'".
  "GROUP BY type, member_id ";  
 
$chkd['n'] = 1;
$chkd['c'] = 1;
$chkd['l'] = 1;
$chkd['r'] = 1;
$chkd['t'] = 1;
$chkd['d'] = 1;
$chkd['p'] = 1;
$chkd['a'] = 1;
$chkd['i'] = 1;
switch($get_s)
{
        case 'fullname':
                if( $get_d )
                {
                        $query .= ' ORDER BY `fullname` ASC';
                        $chkd['n'] = 0;
                }
                else
                {
                        $query .= ' ORDER BY `fullname` DESC';
                }
        break;
        case 'class':
                if( $get_d )
                {
                        $query .= ' ORDER BY `class` ASC';
                        $chkd['c'] = 0;
                }
                else
                {
                        $query .= ' ORDER BY `class` DESC';
                }
        break;
        case 'title':
                if( $get_d )
                {
                        $query .= ' ORDER BY `guild_rank` ASC';
                        $chkd['l'] = 0;
                }
                else
                {
                        $query .= ' ORDER BY `guild_rank` DESC';
                }
        break;
        case 'points':
                if( $get_d )
                {
                        $query .= ' ORDER BY `points` DESC';
                        $chkd['r'] = 0;
                }
                else
                {
                        $query .= ' ORDER BY `points` ASC';
                }
        break;
        case 'lifetime':
                if( $get_d )
                {
                        $query .= ' ORDER BY `lifetime` DESC';
                        $chkd['t'] = 0;
                }
                else
                {
                        $query .= ' ORDER BY `lifetime` ASC';
                }
        break;
        case 'spent':
                if( $get_d )
                {
                        $query .= ' ORDER BY `SUM(value)` ASC, `type` ASC';
                        $chkd['p'] = 0;
                }
                else
                {
                        $query .= ' ORDER BY `SUM(value)` DESC, `type` DESC';
                }
        break;
        case 'items':
                if( $get_d )
                {
                        $query .= ' ORDER BY `COUNT(reason)` DESC, `type` ASC';
                        $chkd['i'] = 0;
                }
                else
                {
                        $query .= ' ORDER BY `COUNT(reason)` ASC, `type` ASC';
                }
        break;
                case 'lastadd':
                if( $get_d )
                {
                        $query .= ' ORDER BY `lastadd` DESC, `type` ASC';
                        $chkd['a'] = 0;
                }
                else
                {
                        $query .= ' ORDER BY `lastadd` ASC, `type` ASC';
                }
        break;
        default:
                $query .= ' ORDER BY `SUM(value)` ASC, `type` DESC';
                break;
}
$content = '';
if ($roster_conf['sqldebug'])
        $content .= ("<!--$query-->\n");
$result = $wowdb->query($query) or die_quietly($wowdb->error(),'Database Error',basename(__FILE__),__LINE__,$query);
$max = $wowdb->num_rows($result);
$sort_part = ($get_s != '' ? "&amp;s=$get_s" : '');
$sort_part .= ($get_d != 0 ? "&amp;d=$get_d" : '');
if ($start > 0)
{
        $prev = '<a href="'.$script_filename.'0'.$sort_part.'">&lt;&lt;</a> <a href="'.$script_filename.max($start-30,0).$sort_part.'">&lt;</a> ';
}
if (($start+30) < $max)
{
        $lastpage = ceil($max/30)*30;
        $listing = ' <a>['.$start.' - '.($start+30).'] of '.$max.'</a>';
        $next = ' <a href="'.$script_filename.($start+30).$sort_part.'">&gt;</a> <a href="'.$script_filename.($lastpage-30).$sort_part.'">&gt;&gt;</a>';
}
else
{
        $listing = ' <a>['.$start.' - '.($max).'] of '.$max.'</a>';
} 
    $tableHeader = '<table id="rolling" width="100%" cellpadding="2" cellspacing="0" border="0" class="forumline">'."\n";
    $borderTop = '<tr><th colspan="8" class="thCornerL">'.$prev.$wordings[$roster_conf['roster_lang']]['spending'].$listing.$next.'</th></tr>'."\n";
    $borderBottom = '<tr><th colspan="8" class="thCornerL">'.$prev.$wordings[$roster_conf['roster_lang']]['spending'].$listing.$next.'</th></tr></table>';
$query .= ' LIMIT '.$start.' , 30';
$result = $wowdb->query($query) or die_quietly($wowdb->error(),'Database Error',basename(__FILE__),__LINE__,$query);
if ($roster_conf['sqldebug'])
        $content .= ("<!--$query-->\n");
if( $wowdb->num_rows($result) > 0 )
{
        $tableHeaderRow = '<tr>
        <th class="row2" width="10%"><a href="'.$script_filename.$start.'&amp;s=fullname&amp;d='.$chkd['n'].'">'.$wordings[$roster_conf['roster_lang']]['fullname'].'</a></th>
        <th class="row2" width="10%"><a href="'.$script_filename.$start.'&amp;s=class&amp;d='.$chkd['c'].'">'.$wordings[$roster_conf['roster_lang']]['class'].'</a></th>
        <th class="row2" width="10%"><a href="'.$script_filename.$start.'&amp;s=title&amp;d='.$chkd['l'].'">'.$wordings[$roster_conf['roster_lang']]['title'].'</a></th>
        <th class="row2" width="5%"><a href="'.$script_filename.$start.'&amp;s=lifetime&amp;d='.$chkd['t'].'">'.$wordings[$roster_conf['roster_lang']]['lifetime'].'</a></th>
        <th class="row2" width="5%"><a href="'.$script_filename.$start.'&amp;s=spent&amp;d='.$chkd['p'].'">'.$wordings[$roster_conf['roster_lang']]['spent'].'</a></th>
        <th class="row2" width="5%"><a href="'.$script_filename.$start.'&amp;s=points&amp;d='.$chkd['r'].'">'.$wordings[$roster_conf['roster_lang']]['points'].'</a></th>
        <th class="row2" width="5%"><a href="'.$script_filename.$start.'&amp;s=items&amp;d='.$chkd['i'].'">'.$wordings[$roster_conf['roster_lang']]['items'].'</a></th>
        <th class="row2" width="20%"><a href="'.$script_filename.$start.'&amp;s=lastadd&amp;d='.$chkd['a'].'">'.$wordings[$roster_conf['roster_lang']]['lastadd'].'</a></th>
        </tr>'."\n";
        while( $row = $wowdb->fetch_assoc($result) )
        {
                foreach( $row as $key => $value )
                {
                        $row[$key] = $wowdb->escape($value);
                
                }
                
                $lastaddUTC = $row['lastadd'];
                $lastadd = UpDatelastadd($lastaddUTC);
                
                
                if( $row['SUM(value)'] < 0 ){
                        $row['SUM(value)']  = '<span class="red">'.$row['SUM(value)'].'</span>';
                        }
                        
                if( $row['lifetime'] > 0 ) {
                  $row['lifetime']  = '<span class="blue">'.$row['lifetime'].'</span>';
            }
      
    if ($row['points'] > 0 ) {
             $row['points'] = '<span class="green">'.$row['points'].'</span>';
             
      }      
require($addonDir.'lib/classname.php');
require($addonDir.'lib/classrank.php');      
     $class_name = $row['class'];
      $icon_value = class_value($class_name);
     
                    $body .= '
                    <tr>
                          <td class="row1" align="left">'.$row['fullname'].'</td>
                          <td class="row1" align="left">'.$icon_value.'</td>
                          <td class="row1" align="center">'.$row['guild_title'].'</td>
                          <td class="row1" align="center">'.$row['lifetime'].'</td>
                          <td class="row1" align="center">'.$row['SUM(value)'].'</td>
                          <td class="row1" align="center">'.$row['points'].'</td>
                          <td class="row1" align="center">'.$row['COUNT(reason)'].'</td>
                          <td class="row1" align="center">'.$lastadd.'</td>
                    </tr>'."\n";
        }  
}
else
{
        $body = '<tr><td class="row1" align="center">'.$wordings[$roster_conf['roster_lang']]['nokarmahistory'].'</td></tr>';
}  
    $content .= $tableHeader;
    $content .= $borderTop;
    $content .= $tableHeaderRow;
    $content .= $body;
    $content .= $borderBottom;

$wowdb->closeQuery($result);
$wowdb->free_result($result);
print $content;
   function UpDatelastadd($lastaddUTC)
  {
        global $roster_conf, $phptimeformat;
        list($month, $day, $year, $hour, $minute, $second) = sscanf($lastaddUTC,"%d/%d/%d %d:%d:%d");
        $localtime = mktime($hour+0 ,$minute, $second, $month, $day, $year, -0);
        return date($phptimeformat[$roster_conf['roster_lang']], $localtime);
        }