<?php
/******************************
 * WoWRoster.net  Roster
 * Copyright 2002-2007
 * Licensed under the Creative Commons
 * "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * Short summary
 *  http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * Full license information
 *  http://creativecommons.org/licenses/by-nc-sa/2.5/legalcode
 * -----------------------------
 *
 * org by zanix $
 * $Id: fullkarmahistory.php
 * @version    1.1.1 
 * remixed for addon karmahistory date 20008-06-03 Tennessee $ 
 ******************************/
     if ( !defined('ROSTER_INSTALLED') )
{
    exit('Detected invalid access to this file!');
}

$mystart=3;
 $script_filename = ('&amp;start=');
 $link_filename = ('addon.php?roster_addon_name=karmahistory&amp;f=full');
$query =
        'SELECT '.
// we limit down what it actually pulls
// The query is a lot simpler than it looks...
// Fields to get from the karma table
  '`karma`.`member_id`, '.
  '`karma`.`DT`, '.
  '`karma`.`class`, '.
  '`karma`.`shortdt`, '. 
        '`karma`.`value`, '.
        '`karma`.`type`, '.
        '`karma`.`fullname`, '.
        '`karma`.`reason`, '.
        
// Fields to get from the members table 
        '`members`.`member_id`, '.
        '`members`.`zone`, '.
  '`members`.`last_online`, '.
        '`members`.`guild_rank`, '.
        '`members`.`guild_title` '.
  
  "FROM `".ROSTER_KARMAITEMSTABLE."` AS karma ".
// All those people asking about guild searching, here's a spot!  and here's the simple alteration to stop guild filtering in this particular place     
        "LEFT JOIN `".ROSTER_MEMBERSTABLE."` AS members ON `karma`.`member_id` = `members`.`member_id` ";
    if( (isset($_REQUEST['filter'])) && (($_REQUEST['filter']) != 'All') )
                $query .= " WHERE members.guild_title='".$_REQUEST['filter']."'";
          
    if ($_REQUEST['filter']){  
    $script_filename = ('&amp;start=&amp;filter='.$_REQUEST['filter']);
    }
    else
    {    
    //$script_filename = ('');
     }
    if( (isset($_REQUEST['dtdate'])) && (($_REQUEST['dtdate']) != 'All') )
                $query .= " WHERE karma.shortdt='".$_REQUEST['dtdate']."'";
                
                if ($_REQUEST['dtdate']){  
    $script_filename = ('&amp;start=&amp;dtdate='.$_REQUEST['dtdate']);
    }
    else
    {    
    //$script_filename = ('');
                }
                if( (isset($_REQUEST['opfname'])) && (($_REQUEST['opfname']) != 'All') )
                $query .= " WHERE karma.fullname='".$_REQUEST['opfname']."'";
                
                if ($_REQUEST['opfname']) { 
    $script_filename = ('&amp;start=&amp;opfname='.$_REQUEST['opfname']);
    }
    else 
    {   
    //$script_filename = ('');
                 }
                if( (isset($_REQUEST['filterclass'])) && (($_REQUEST['filterclass']) != 'All') )
                $query .= " WHERE karma.class='".$_REQUEST['filterclass']."'";
                
                if ($_REQUEST['filterclass']) { 
    $script_filename = ('&amp;start=&amp;filterclass='.$_REQUEST['filterclass']);
    }
    else 
    {   
    //$script_filename = ('');
                 }
                
    $get_d = ( isset($_REQUEST['d']) ? intval($_REQUEST['d']) : 0 );
    $get_s = ( isset($_REQUEST['s']) ? $_REQUEST['s'] : '' );
        
// Check for start for pagination
$start = (isset($_REQUEST['start']) ? $_REQUEST['start'] : 0);
                
$chkd['n'] = 1;
$chkd['c'] = 1;
$chkd['l'] = 1;
$chkd['r'] = 1;
$chkd['t'] = 1;
$chkd['d'] = 1;
switch($get_s)
{
        case 'fullname':
                if( $get_d )
                {
                        $query .= ' ORDER BY `fullname` ASC';
                        $chkd['n'] = 0;
                }
                else
                {
                        $query .= ' ORDER BY `fullname` DESC';
                }
        break;
        case 'class':
                if( $get_d )
                {
                        $query .= ' ORDER BY `class` ASC';
                        $chkd['c'] = 0;
                }
                else
                {
                        $query .= ' ORDER BY `class` DESC';
                }
        break;
        case 'DT':
                if( $get_d )
                {
                        $query .= ' ORDER BY `DT` DESC';
                        $chkd['l'] = 0;
                }
                else
                {
                        $query .= ' ORDER BY `DT` ASC';
                }
        break;
        case 'title':
                if( $get_d )
                {
                        $query .= ' ORDER BY `guild_rank` ASC';
                        $chkd['r'] = 0;
                }
                else
                {
                        $query .= ' ORDER BY `guild_rank` DESC';
                }
        break;
        case 'value':
                if( $get_d )
                {
                        $query .= ' ORDER BY `value` DESC';
                        $chkd['t'] = 0;
                }
                else
                {
                        $query .= ' ORDER BY `value` ASC';
                }
        break;
        case 'reason':
                if( $get_d )
                {
                        $query .= ' ORDER BY `reason` DESC';
                }
                else
                {
                        $query .= ' ORDER BY `reason` ASC';
                }
        break;
        default:
                $query .= ' ORDER BY `DT` DESC';
                break;
}
$content = '';
  
if ($roster_conf['sqldebug'])
        $content .= ("<!--$query-->\n");
$result = $wowdb->query($query) or die_quietly($wowdb->error(),'Database Error',basename(__FILE__),__LINE__,$query);
$max = $wowdb->num_rows($result);
$sort_part = ($get_s != '' ? "&amp;s=$get_s" : '');
$sort_part .= ($get_d != 0 ? "&amp;d=$get_d" : '');
if ($start > 0)
{
        $prev = '<a href="'.$link_filename.$script_filename.'0'.$sort_part.'">&lt;&lt;</a> <a href="'.$link_filename.$script_filename.max($start-30,0).$sort_part.'">&lt;</a> ';
}
if (($start+30) < $max)
{
        $lastpage = ceil($max/30)*30;
        $listing = ' <a>['.$start.' - '.($start+30).'] of '.$max.'</a>';
        $next = ' <a href="'.$link_filename.$script_filename.($start+30).$sort_part.'">&gt;</a> <a href="'.$link_filename.$script_filename.($lastpage-30).$sort_part.'">&gt;&gt;</a>';
}
else
{
        $listing = ' <a>['.$start.' - '.($max).'] of '.$max.'</a>';
}
    $tableHeader = '<table id="rolling" width="100%" cellpadding="2" cellspacing="0" border="0" class="forumline">'."\n";
    $borderTop = '<tr><th colspan="8" class="thCornerL">'.$prev.$wordings[$roster_conf['roster_lang']]['karmafullhistory'].$listing.$next.'</th></tr>'."\n";
    $borderBottom = '<tr><th colspan="8" class="thCornerL">'.$prev.$wordings[$roster_conf['roster_lang']]['karmafullhistory'].$listing.$next.'</th></tr></table>';


$query .= ' LIMIT '.$start.' , 30';
$result = $wowdb->query($query) or die_quietly($wowdb->error(),'Database Error',basename(__FILE__),__LINE__,$query);
if ($roster_conf['sqldebug'])
        $content .= ("<!--$query-->\n");
$striping_counter = 0;
if( $wowdb->num_rows($result) > 0 )
{
        $tableHeaderRow = '     <tr>
       <th class="row2" width="5%"><a href="'.$link_filename.$script_filename.$start.'&amp;s=fullname&amp;d='.$chkd['n'].'">'.$wordings[$roster_conf['roster_lang']]['fullname'].'</a></th>
        <th class="row2" width="5%"><a href="'.$link_filename.$script_filename.$start.'&amp;s=class&amp;d='.$chkd['c'].'">'.$wordings[$roster_conf['roster_lang']]['class'].'</a></th>
        <th class="row2" width="10%"><a href="'.$link_filename.$script_filename.$start.'&amp;s=title&amp;d='.$chkd['r'].'">'.$wordings[$roster_conf['roster_lang']]['title'].'</a></th>
        <th class="row2" width="20%"><a href="'.$link_filename.$script_filename.$start.'&amp;s=DT&amp;d='.$chkd['l'].'">'.$wordings[$roster_conf['roster_lang']]['date'].'</a></th>
        <th class="row2" width="5%"><a href="'.$link_filename.$script_filename.$start.'&amp;s=value&amp;d='.$chkd['t'].'">'.$wordings[$roster_conf['roster_lang']]['type'].'</a></th>
        <th class="row2" width="5%"><a href="'.$link_filename.$script_filename.$start.'&amp;s=value&amp;d='.$chkd['t'].'">'.$wordings[$roster_conf['roster_lang']]['ammount'].'</a></th>
        <th class="row2" width="30%">'.$wordings[$roster_conf['roster_lang']]['item'].'</th>
        </tr>'."\n";
        while( $row = $wowdb->fetch_assoc($result) )
        {
                foreach( $row as $key => $value )
                {
                        $row[$key] = $wowdb->escape($value);            
          }
                if( $row['value'] < 0 ) {               
                        $row['value'] = '<span class="red">'.$row['value'].'</span>';
                        $row['thvalue'] = '<span class="red">'.$wordings[$roster_conf['roster_lang']]['removed'].'</span>';               
    } else {
      
                        $row['value'] = '<span class="green">'.$row['value'].'</span>';
                        $row['thvalue'] = '<span class="green">'.$wordings[$roster_conf['roster_lang']]['added'].'</span>';
                        }
                if( $row['type'] == I )  {
                        
      if ($addon_conf['karmahistory']['useitemstats'] == 1)
     {      
                        $message = '[itemico]'.$row['reason'].'[/itemico]&nbsp;'.'&nbsp;[item]'.$row['reason'].'[/item]';                         
      $item =  itemstats_parse($message);
      }
      else 
      {
      $item = '<a class="wowdb-item-full-small" href="'.$addon_conf['karmahistory']['noitemstats'].$row['reason'].'">'.$row['item_name'].'</a>';
      }
     }
  else
    {
     $item =  $row['reason'];  
     }
require($addonDir.'lib/classname.php');
require($addonDir.'lib/classrank.php');           
      $class_name = $row['class'];
      $icon_value = class_value($class_name);
      $DTutc  = $row['DT'];
      $DTdate = UpDateDT($DTutc);               
   
                $body .= '<tr >
                <td class="row1" align="left">'.$row['fullname'].'</td>
                <td class="row1" align="left">'.$icon_value.'</td>
                <td class="row1" align="center">'.$row['guild_title'].'</td>
                <td class="row1" align="center">'.$DTdate.'</td>
                <td class="row1" align="center">'.$row['thvalue'].'</td>
                <td class="row1" align="center">'.$row['value'].'</td>
                <td class="row1" align="left">'.$item.'</td>
                </tr>'."\n";
        }  
}
else
{
        $body = '<tr><td class="row1" align="center">'.$wordings[$roster_conf['roster_lang']]['nokarmahistory'].'</td></tr>';
}
$content .= $tableHeader;
$content .= $borderTop;
$content .= $tableHeaderRow;
$content .= $body;
$content .= $borderBottom;
$wowdb->closeQuery($result);
$wowdb->free_result($result);
print $content;