<?php
/******************************
 * WoWRoster.net  Roster
 * Copyright 2002-2007
 * Licensed under the Creative Commons
 * "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * Short summary
 *  http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * Full license information
 *  http://creativecommons.org/licenses/by-nc-sa/2.5/legalcode
 * -----------------------------
 *
 * org by zanix $
 * Id: updatekarma.php
 * @version    1.0.2 
 * remixed for addon karmahistory date 20008-05-19 02:02:00 Tennessee $
 * http://www.wowroster.net/Forums/viewtopic/t=5358.html  
 ******************************/
if ($roster_conf['sqldebug'])
{
	print "<!-- $query -->\n";
}
//---[ Update File Downloader ]-----------------------------
if( isset($_POST['send_file']) && !empty($_POST['send_file']) && !empty($_POST['data']) )
{
	$file = $_POST['data'];
	header('Content-Type: text/x-delimtext; name="'.$_POST['send_file'].'_log.txt"');
	header('Content-disposition: attachment; filename="'.$_POST['send_file'].'_log.txt"');
	// We need to stripslashes no matter what the setting of magic_quotes_gpc is
	echo stripslashes($file);
	exit;
}
$mystart=3;
require_once( 'settings.php' );
require_once('lib/lua2phparray.php');
$script_filename = ('');
// Set $htmlout to 1 to assume request is from a browser
$htmlout = 1;
// Files that we accept for upload. Up to the first dot, lowercase.
//----- karma   -----//
$filefields[] = 'ni_karma';
//----- karma   -----//
// Initialize some vars
$uploadFound = false;
$uploadData = null;
if( is_array($_FILES) && !empty($_FILES) )
{
	$uploadFound = true;
	$parseMessages = 'Parsing files'."<br />\n".'<ul>';
	// Loop through each posted file
	foreach( $_FILES as $filefield => $file )
	{
		if( !empty($file['name']) )
		{
			$file_name=$file_ext=$file_type='';
			list( $file_name, $file_ext, $file_type ) = explode( '.',$file['name'] );
			if( in_array(strtolower($file_name),$filefields) )
			{
				// Filefield is 1 of the kind we accept.
				if( $roster_conf['authenticated_user'] )
				{
					// Get start of parse time
					$parse_starttime = explode(' ', microtime() );
					$parse_starttime = $parse_starttime[1] + $parse_starttime[0];
					// Parse the lua file into a php array that we can use
					$data = makePhpArray( $file['tmp_name'],$file_type );
					// Calculate parse time
					$parse_endtime = explode(' ', microtime() );
					$parse_endtime = $parse_endtime[1] + $parse_endtime[0];
					$parse_totaltime = round(($parse_endtime - $parse_starttime), 2);
					if( $data )
					{
						$parseMessages .= '<li>Parsed '.$file_name.' in '.$parse_totaltime.' seconds</li>'."\n";
					}
					else
					{
						$parseMessages .= '<li>Error while parsing '.$file_name.' after '.$parse_totaltime.' seconds</li>'."\n";
					}					
			//----- karma   -----//
					// If ni karma data is there, assign it to $uploadData['raiddata']
					if( isset($data['KarmaList']) )
					{
						$uploadData['raiddata'] = $data;
					}
			//----- karma   -----//					
					// Clear the $data variable
					unset($data);
				}
			}
			else
			{
				$parseMessages .= '<li>Did not accept '.$file['name'].'</li>'."\n";
			}
		}
		@unlink($filename);	// Done with the file, we don't need it anymore
	}
	$parseMessages .= '</ul>'."<br />\n";
}
//----- karma   -----//
// If the roster update password is sent and matches, and uploadData['raiddata'] is there, update the karmapoints
if( is_array($uploadData['raiddata']) && isset($_POST['password']) )
{
	if( ( md5($_POST['password']) == $roster_conf['roster_upd_pw'] ) ||
		( $_POST['password'] == $roster_conf['roster_upd_pw'] ) ||
		( $roster_conf['phpbb_authenticated_admin'] )
	  )
	{
		$rosterUpdateMessages = processraiddata($uploadData['raiddata']);
	}
}
//----- Process Raid Data   karma -----//
function processraiddata($karmadata)
{
global $wowdb, $roster_conf, $addon_conf, $wordings, $messages;
	$wowdb->resetMessages();
	foreach( array_keys( $karmadata['KarmaList'] ) as $database_name )
	{  
    $database = $addon_conf['karmahistory']['database']; 		
    if( $database  == $database_name )
 		{
      $characters = $karmadata['KarmaList'][$database];
			$output .= "<strong>Using Database [<span class=\"blue\">$database</span>]</strong><br />\n";
			foreach( array_keys( $characters ) as $char_name)
	   		{
				$char = $characters[$char_name];
				$char_fullname = $char['fullname'];
				// Karma Detection, don't allow 0 karma
				if( $char['lifetime'] > 0 )
				{
				update_karma( $char_name, $char, $char_fullname );          
				$output .= "<ul>\n".$wowdb->getMessages()."</ul>\n";    
				$wowdb->resetMessages();                              
				}
				else 
				{
				$karma_output .= "<span class=\"red\">NOT Updating character [$char_name]</span><br />\n";
				$karma_output .= "Karma lifetime is  ".$char['lifetime']."<br />\n";
				}
				$output .= "<br />\n";
				}
				$output .= "</ul>\n";
				$output .= "<li><strong>Member Log</strong>\n<ul>\n".
							"<li>Updated: ".$wowdb->membersupdated."</li>\n".    
							"<li>Added: ".$wowdb->membersadded."</li>\n".         
							"<li>Removed: ".$wowdb->membersremoved."</li>\n".      
							"</ul>\n<br />\n";
				$output .= $karma_output;
				
				update_karmalog  ($database_name);
				$output .= "<ul>\n".$wowdb->getMessages()."</ul>\n";
    }
		else
		{  /// this returns only the database set in this file
			$output .= 'Database: '.$database_name.' '.$wordings[$roster_conf['roster_lang']]['karma_nodatabase']."<br />\n";
			$output .= $wordings[$roster_conf['roster_lang']]['karma_nodatabaseor']."<br />\n";
		}
	}
	return $output;
}
//----- End Process Raid Data   karma -----//
//----- karma   -----//

// Get SQL messages
$sqlstringout = $wowdb->getSQLStrings();
$errorstringout = $wowdb->getErrors();
/**
 * Make the html Upload page
 */
 ?>
 <br />
 <br />
 <?php
if( $htmlout )
{
	// Construct the entire upload form
	$inputForm = "
                <form action=\"$script_filename\" enctype=\"multipart/form-data\" method=\"POST\" onsubmit=\"submitonce(this)\">
".border('','start','')."
                  <table class=\"forumline\" cellspacing=\"1\" cellpadding=\"2\">
                    <tr>
                      <th class=\"thCornerL\" colspan=\"2\"></th>
                    </tr>
                    <tr>
                      <td class=\"row1\" align=\"left\"<b>Ni_Karma.lua</b></td>
                      <td class=\"row2\" align=\"left\"><input type=\"file\" accept=\"CharacterProfiler.lua\" name=\"CharacterProfiler\"></td>
                    </tr>
                    <tr>
                      <td class=\"row1\" align=\"left\">Update password</td>
                      <td class=\"row2\" align=\"left\"><input type=\"password\" name=\"password\"></td>
                    </tr>
                  </table>
".border('','end')."<br />
                  <input type=\"submit\" value=\"".$wordings[$roster_conf['roster_lang']]['upload']."\">";
	$inputForm .= "\n                </form>";
	if( !$roster_conf['authenticated_user'] )
	{
		print messagebox($wordings[$roster_conf['roster_lang']]['update_disabled'],$wordings[$roster_conf['roster_lang']]['update_page'],'sred');
	}
	else
	{
		print '<span class="title_text">Ni_Karma.lua Only</span><br /><br /><br />';
		if( $uploadFound )
		{
			// print the error messages
			if( !empty($errorstringout) )
			{
				print
				'<div id="errorCol" style="display:inline;">
					'.border('sred','start',"<div style=\"cursor:pointer;width:550px;\" onclick=\"swapShow('errorCol','error')\"><img src=\"".$roster_conf['img_url']."plus.gif\" style=\"float:right;\" /><span class=\"red\">Update Errors</span></div>").'
					'.border('sred','end').'
				</div>
				<div id="error" style="display:none">
				'.border('sred','start',"<div style=\"cursor:pointer;width:550px;\" onclick=\"swapShow('errorCol','error')\"><img src=\"".$roster_conf['img_url']."minus.gif\" style=\"float:right;\" /><span class=\"red\">Update Errors</span></div>").
				$errorstringout.
				border('sred','end').
				'</div>';
				// Print the downloadable errors separately so we can generate a download
				print "<br />\n";
				print '<form method="post" action="'.$script_filename.'" name="post">'."\n";
				print '<input type="hidden" name="data" value="'.htmlspecialchars(stripAllHtml($errorstringout)).'" />'."\n";
				print '<input type="hidden" name="send_file" value="error" />'."\n";
				print '<input type="submit" name="download" value="Save Error Log" />'."\n";
				print '</form>';
				print "<br />\n";			}

			// Print the update messages
			print
				border('','start','Update Log').
				'<div style="font-size:10px;background-color:#1F1E1D;text-align:left;height:300px;width:550px;overflow:auto;">'.
					$parseMessages.
					$updateMessages.
					$updatePvPMessages.
					$rosterUpdateMessages.
				'</div>'.
				border('','end');
			// Print the downloadable messages separately so we can generate a download
			print "<br />\n";
			print '<form method="post" action="'.$script_filename.'" name="post">'."\n";
			print '<input type="hidden" name="data" value="'.htmlspecialchars(stripAllHtml($updateMessages.$updatePvPMessages.$rosterUpdateMessages)).'" />'."\n";
			print '<input type="hidden" name="send_file" value="update" />'."\n";
			print '<input type="submit" name="download" value="Save Update Log" />'."\n";
			print '</form>';
			print "<br />\n";
		}
		else
		{
			print $inputForm;
		}
	}
}
else	// Dont need the header and footer when responding to UU
{
	if( !$roster_conf['authenticated_user'] )
	{
		print $wordings[$roster_conf['roster_lang']]['update_disabled'];
	}
	else
	{
		if( $uploadFound )
		{
			// Strip all html tags out, then print
			print stripAllHtml(
					$parseMessages.
					$updateMessages.
					$updatePvPMessages.
					$rosterUpdateMessages
				);
		}
		else
		{
			// Weren't any files in the upload that correspond to anything in the array of filefields that we take.
			print $wordings[$roster_conf['roster_lang']]['nofileUploaded'];
		}
	}
}
//---------------------------------------------------------------------------------------
function update_karmalog( $database_name )
	{ global $addon_conf, $wowdb, $roster_conf;
    $database = $database_name;
    $karmaId = '1';
		$wowdb->reset_values();
		
		//date_offset_get($mydate);
		//$update_time = date('l F dS \, h:i A T');
		$timeZoneOffset = $roster_conf['localtimeoffset'];
    $H = (date('h')+date('O'))+$timeZoneOffset; //hour
    $i = date('i'); //minutes
    $update_time = date('D M j\,').date(' g:i A ',mktime($H,$i)).$roster_conf['timezone'];
		$wowdb->add_value( 'karma_name', $database );
    $wowdb->add_value( 'update_time', $update_time );
   	$querystr = "UPDATE `".ROSTER_KARMALOGTABLE."` SET ".$wowdb->assignstr." WHERE `karma_id` = '$karmaId'";
   	$wowdb->setMessage('<li><strong><span class="yellow">'.$database.' has been updated on. </span>'.$update_time.'</strong></li>');
		$wowdb->query($querystr) or die_quietly($wowdb->error(),'WowDB Error',basename(__FILE__).'<br />Function: '.(__FUNCTION__),__LINE__,$querystr);
		return $output;
	}
//------- Update Karma--------------// 
function update_karma( $name, $data, $char_fullname )
	{ global $addon_conf, $wowdb;
	$name_escape = ( $char_fullname ); 
		$querystr = "SELECT `member_id` FROM `".ROSTER_MEMBERLOGTABLE."` WHERE `name` = '$name_escape'";
		$result = $wowdb->query($querystr);		
	if( !$result )
		{
			$wowdb->setError('Cannot select member_id for Character Data',$wowdb->error());
			return;
		}		
		$memberInfo = $wowdb->fetch_assoc( $result );
		$wowdb->closeQuery($result);
		if ($memberInfo)
		{
			$memberId = $memberInfo['member_id'];
		}
	else
		{  // Remove the members who were not in this list
	   	remove_karma_members($name);		                   
			$wowdb->setMessage('<li><strong><span class="red">'.$name.' is not in the list of guild members so their data will not be inserted.</span></strong></li>');
      return;
		}
  if ($addon_conf['karmahistory']['clearplayerdata'] == 1)
     {      
       $querystr = "DELETE FROM `".ROSTER_KARMATABLE."` WHERE `member_id` = '$memberId'";
			if( !$wowdb->query($querystr) )
			{
				$wowdb->setError('Player could not be deleted',$wowdb->error());
				return;
			}
       $wowdb->setMessage('<li><strong>Player '.$name.' has been reset</strong></li>');
      }   
		$querystr = "SELECT `member_id` FROM `".ROSTER_KARMATABLE."` WHERE `member_id` = '$memberId'";
		$result = $wowdb->query($querystr);
	if( !$result )
		{
		$wowdb->setError('Cannot select member_id for Karma Data',$wowdb->error());
	return;
		}      
		$update = $wowdb->num_rows( $result ) == 1;		
		$wowdb->closeQuery($result);
		$wowdb->reset_values();
		$wowdb->add_value( 'points', $data['points'] );
		$wowdb->add_value( 'lifetime', $data['lifetime'] );
		$wowdb->add_value( 'lastadd', $data['lastadd'] );
	if( $update )
		{
		$querystr = "UPDATE `".ROSTER_KARMATABLE."` SET ".$wowdb->assignstr." WHERE `member_id` = '$memberId'";
		$wowdb->setMessage('<li> '.$name.' <span class="yellow"> - Updated</span></li></br>');
		$result = $wowdb->query($querystr);
    $wowdb->membersupdated++;
	if( !$result )
		{
	 $wowdb->setError('Cannot update Character\'s Karma Data',$wowdb->error());
	return;
	  }
	  }
else
		{
	if( !empty($memberId) )
		$wowdb->add_value( 'member_id', $memberId );
		$wowdb->add_value( 'class', $data['class'] );
		$wowdb->add_value( 'fullname', $data['fullname'] );
		$wowdb->add_value( 'name', $name );		
		$querystr = "INSERT INTO `".ROSTER_KARMATABLE."` SET ".$wowdb->assignstr;
		$wowdb->setMessage('<li><strong><span class="green">Added Player </span> '.$name.' </strong></li></br>');
		$result = $wowdb->query($querystr);
		$wowdb->membersadded++;
	if( !$result )
    {
	  $wowdb->setError('Cannot Add Character\'s Karma Data',$wowdb->error());
	return;
		}	
	 } 
	 do_karma( $data, $memberId, $name ); 		
  }
//------END update_karma--//	
//----- Do Karma items   -----//
function do_karma( $data, $memberId, $name )
	{ global $addon_conf, $wowdb;
	
	if ($addon_conf['karmahistory']['clearitemdata'] == 1)
     {      
       $querystr = "DELETE FROM `".ROSTER_KARMAITEMSTABLE."` WHERE `member_id` = '$memberId'";
			if( !$wowdb->query($querystr) )
			{
				$wowdb->setError('items could not be deleted',$wowdb->error());
				return;
			}
       $wowdb->setMessage('<li><strong>All items for '.$data['fullname'].' have been reset</strong></li>');
      }	
		$playersdata = $data;	
		if( !empty($playersdata) && is_array($playersdata) )
		{
		$wowdb->setMessage('<li><strong><span class="yellow">Updating Karma items for '.$data['fullname'].'</span></strong></li>');   
			foreach( array_keys( $playersdata ) as  $events )
			{ 
				$eventdata = $playersdata[$events];
				if( is_null($eventdata) || !is_array($eventdata) || empty($eventdata) )
				{
					continue;
				}			
			if ( $eventdata['type'] == 'I' )
         {		  
         $ctr=0;
         $item_id = '';
         $reasonsname = '';
		     preg_match_all('/[^|]+/i', $eventdata['reason'], $words);
         preg_match_all('/[^:]+/i', $words[0][1], $item);     // $words[0][0]; = color of the item 
			   $reasonsname .= substr($words[0][2], 2, -1);     //name of the item
         $item_id .= $item[0][1];                        // item number 			  			  
		     $itemd = $item_id;
		     $item_name = $reasonsname;
				 }
         elseif ($eventdata['type'] == 'P')
          {         
          $itemd = $eventdata['reason'];
          $item_name = '';
          }         			
			    $item = make_karma( $eventdata, $memberId, $name, $events, $itemd, $item_name );				
   $querystr = "SELECT `item_slot` FROM `".ROSTER_KARMAITEMSTABLE."` WHERE `member_id` = '$memberId' AND `item_slot` = '".$item['item_slot']."'";
	 $result = $wowdb->query($querystr);
	 if( !$result )
	     	{
		    $wowdb->setError('Cannot select member_id for Karma Data',$wowdb->error());
     	return;
	     	}
        $update = $wowdb->num_rows( $result );		
		    $wowdb->closeQuery($result);
	     	$wowdb->reset_values();
	   if( $update )
		      {
		      //where not gona do anything
          }
	   else
         {   
        $wowdb->setMessage('<span class="green">:' .$events.'</span>');           			
				insert_karma($data, $item, $data['Locale'] );							  
			}
     }
		}
		else
		{
			$wowdb->setMessage('<li>No Karma Data</li>');
		}
	}
//----- End Do Karma items   -----//	
//-----  Karma Make items  -----//
function make_karma( $item_data, $memberId, $name, $events, $itemd, $item_name )
	{    global $wowdb;    
		$item = array();			
    $item['item_slot'] = $events;					
		$item['member_id'] = $memberId;
		$item['item_parent'] = $name;
		$item['value'] = $item_data['value'];
		$item['type'] = $item_data['type'];
		$item['reason'] = $itemd;
		$item['item_name'] = $item_name;		
		$item['DT'] = $item_data['DT'];
		$item['shortdt'] = $item_data['DT'];
		return $item;
	}
//----- End   Make items  -----//	
//-----   Insert items  -----//
function insert_karma($data, $item, $locale )
	{    global $wowdb; 
		$wowdb->reset_values();
		$wowdb->add_value('item_slot', $item['item_slot'] );		
		$wowdb->add_value('member_id', $item['member_id'] );
		$wowdb->add_value('item_parent', $item['item_parent'] );
		$wowdb->add_value('value', $item['value'] );
		$wowdb->add_value('type', $item['type'] );
		$wowdb->add_value('reason', $item['reason'] );
		$wowdb->add_value('item_name', $item['item_name'] );
		$wowdb->add_value('DT', $item['DT'] );
		$wowdb->add_value('shortdt', $item['shortdt'] );
		$wowdb->add_value('class', $data['class'] );
		$wowdb->add_value('fullname', $data['fullname'] );
		$querystr = "INSERT INTO `".ROSTER_KARMAITEMSTABLE."` SET ".$wowdb->assignstr;
		$result = $wowdb->query($querystr);
		if( !$result )
		{
			$wowdb->setError('Item ['.$item.'] could not be inserted',$wowdb->error());
		}		
	}
//-----   Insert items  -----//
//---------remove members--------------------------------//
function remove_karma_members($name)
	{    global $wowdb;
		$querystr = "SELECT * FROM `".ROSTER_KARMATABLE."` WHERE `fullname` = '$name'";			
		$result = $wowdb->query($querystr);
		if( !$result )
		{
			$wowdb->setError('Members could not be selected for deletion',$wowdb->error());
			return;
		}
		$num = $wowdb->num_rows($result);
		$inClause = '';
		if ($num > 0)
		{
			while ( $row = $wowdb->fetch_array($result) )
			{
			if ($inClause != '')
					$inClause .= ',';
				$inClause .= $row[0];
				$wowdb->setMessage('<li><span class="red">[</span> '.$row[1].' <span class="red">] - Deleted</span></li>');
				$wowdb->setMemberLog($row,0);
			}
			$wowdb->setMessage('<li><span class="red">Deleted '.$num.' member'.($num > 1 ? 's' : '').'</span>');
			$wowdb->setMessage('<ul>');
			// now that we have our inclause, time to do some deletes
			deleteMembers($inClause);
			$wowdb->setMessage('</ul></li>');
		}
		$wowdb->closeQuery($result);
	}
function deleteMembers( $inClause )
	{      global $wowdb;
		$wowdb->setMessage('<li>');
		$wowdb->setMessage('Character Data..');
		$querystr = "DELETE FROM `".ROSTER_KARMATABLE."` WHERE `member_id` IN ($inClause)";
		if( !$wowdb->query($querystr) )
		{
			$wowdb->setError('Member Data could not be deleted',$wowdb->error());
		}
		$wowdb->setMessage('Items..');
		$querystr = "DELETE FROM `".ROSTER_KARMAITEMSTABLE."` WHERE `member_id` IN ($inClause)";
		if( !$wowdb->query($querystr) )
		{
			$wowdb->setError('Items Data could not be deleted',$wowdb->error());
		}
    $wowdb->setMessage('</li>');
	}